#include "interface/ROOTLoader.h"
#include "interface/SimHistoryTool.h"
#include "interface/SimClusterMerger.h"

#include <memory>
int main() {
  std::unique_ptr<ROOTLoader> rootLoader =  std::make_unique<ROOTLoader>("/ceph/abrusamolino/PFTruthSamples/COCOATests/SingleElectron_Geant4_FlatEtaPt.root", "Out_Tree");


  const std::vector<HitsSoA> hitsSoA = rootLoader->getHitsSoA();
  std::vector<SimShowerCollection> simShowers = rootLoader->getSimShowers();
  std::cout << __FILE__ << " " << __LINE__ << std::endl;
  const std::vector<SimTrackCollection> simTracks = rootLoader->getSimTracks();
  const std::vector<SimVertexCollection> simVertices = rootLoader->getSimVertices();

  Long64_t nEvents = rootLoader->nEvents();

  std::vector<SimShowerCollection> mergedSimShowers;
  mergedSimShowers.resize(nEvents);
  for (unsigned int i = 0; i < nEvents; ++i) {
    const SimHistoryTool shtools(simTracks[i], simVertices[i]); 
    SimClusterMerger scMerger(&hitsSoA[i], &shtools);
    std::vector<std::vector<size_t>> idx;
    std::vector<SimShower> mergedSimShower = scMerger.merge(simShowers[i], idx);
    mergedSimShowers[i].reserve(mergedSimShower.size());
    mergedSimShowers[i] = mergedSimShower;
    mergedSimShower.clear();
  }
  rootLoader->saveMergedSimShowers(mergedSimShowers);
}