import numpy as np
from tools import makeCSVFile

class hits:
  
  def __init__(self, x, y, bins, csv_path, event):
    self.x = x
    self.y = y
    self.bins = bins
    self.hits_x, self.hits_y, self.hits_energy, self.hits_detid = self.makeHits()
    self.csv_path = csv_path
    self.event = event
    self.dictionary()

  def makeHits(self):
    h, xedges, yedges = np.histogram2d(self.x, self.y, bins=self.bins)
    xcenters = [0.5*(xedges[i] + xedges[i-1]) for i in range(1, len(xedges))]
    ycenters = [0.5*(yedges[i] + yedges[i-1]) for i in range(1, len(yedges))]
    content, detid, hits_x, hits_y = [], [], [], []
    for x_bin in range(0, len(self.bins)-1):
        for y_bin in range(0, len(self.bins)-1):
            content.append(h[x_bin][y_bin])
            hits_x.append(xcenters[x_bin])
            hits_y.append(ycenters[y_bin])
            detid.append(x_bin + y_bin * len(h))

    return hits_x, hits_y, content, detid
  
  def dictionary(self):
    dictionary = {'hits_x': self.hits_x,
                  'hits_y': self.hits_y,
                  'hits_z': [0 for _ in range(len(self.hits_x))],
                  'hits_energy': self.hits_energy,
                  'hits_id': self.hits_detid,
                  'hits_t': [0 for _ in range(len(self.hits_x))],
                  'hits_event': [self.event for _ in range(len(self.hits_x))]}
    makeCSVFile(dictionary, self.csv_path)