import pandas as pd
import glob

def makeCSVFile(dictionary, filename):
  df = pd.DataFrame.from_dict(dictionary, orient='index')
  df = df.T
  df.to_csv(filename, index=False)

def mergeCSVFiles(label, tmp_dir, csv_dir):
  merged_df = pd.DataFrame()
  csv_files = glob.glob(tmp_dir+'/*%s*.csv' % label)
  for csv_file in csv_files:
    df = pd.read_csv(csv_file)
    merged_df = pd.concat([merged_df, df], ignore_index=True)
  merged_df.to_csv(csv_dir+'/%s.csv' % label, index=False)