from tools import makeCSVFile

class tracks:
  def __init__(self, centers, n_clusters, n_samples, charges, pfparticles, csv_path, event):
    self.centers = centers
    self.n_clusters = n_clusters
    self.n_samples = n_samples
    self.charges = charges
    self.pfparticles = pfparticles
    self.csv_path = csv_path
    self.event = event

    self.dictionary()

  def dictionary(self):
    dictionary = {'simTrack_momentum_x' : [0 for _ in range(self.n_clusters)],
                  'simTrack_momentum_y' : [0 for _ in range(self.n_clusters)],
                  'simTrack_momentum_z' : [float(nsample) for nsample in self.n_samples],
                  'simTrack_momentum_t' : [float(nsample) for nsample in self.n_samples],
                  'simTrack_track_x' : [self.centers[i][0] for i in range(self.n_clusters)],
                  'simTrack_track_y' : [self.centers[i][1] for i in range(self.n_clusters)],
                  'simTrack_track_z' : [0 for _ in range(self.n_clusters)],
                  'simTrack_trackmomentum_x' : [0 for _ in range(self.n_clusters)],
                  'simTrack_trackmomentum_y' : [0 for _ in range(self.n_clusters)],
                  'simTrack_trackmomentum_z' : self.n_samples,
                  'simTrack_trackmomentum_t' : self.n_samples,
                  'simTrack_tkType' : [0 for _ in range(self.n_clusters)],
                  'simTrack_vertexIndex' : list(range(self.n_clusters)),
                  'simTrack_genParticle' : self.pfparticles,
                  'simTrack_charge' : self.charges,
                  'simTrack_event' : [self.event for _ in range(self.n_clusters)]
                  }
    makeCSVFile(dictionary, self.csv_path)