#ifndef PFParticle_h
#define PFParticle_h

#include<vector>
#include "SimCluster.h"
#include "SimTrack.h"

class PFParticle {
  public:
    PFParticle();
    PFParticle(std::vector<int> simClusters,
               std::vector<int> simTracks,
               float charge, 
               int pdgId) :
      simClusters_(simClusters), simTracks_(simTracks), charge_(charge), pdgId_(pdgId) {}

    void addSimCluster(const int& simCluster) { simClusters_.push_back(simCluster); }
    std::vector<int> simClusters() const { return simClusters_; }

    void addSimTrack(const int& simTrack) { simTracks_.push_back(simTrack); }
    std::vector<int> simTracks() const { return simTracks_; }

    float charge() const { return charge_; }
    int pdgId() const { return pdgId_; } 

  private:
    std::vector<int> simClusters_;
    std::vector<int> simTracks_;
    float charge_;
    int pdgId_;

};

#endif