#ifndef SimHistoryTool_h
#define SimHistoryTool_h

#include<vector>
#include<map>
#include "../interface/SimTrack.h"
#include "../interface/SimVertex.h"
#include "../interface/SimCluster.h"

class SimHistoryTool {
  public:
    SimHistoryTool(const std::vector<SimTrack>& simtracks,
                   const std::vector<SimVertex>& simvertices):
                   simtracks_(simtracks), simvertices_(simvertices) { createIdxAssociation(); }

    SimCluster createMergedSimCluster(std::vector<SimCluster*>) const;
    const SimTrack* getRoot(const SimTrack* st) const;
    const SimTrack* traverseStep(const SimTrack* st) const;
    std::vector<const SimTrack*> createHistory(const SimTrack* st) const;
    bool inHistory(const SimTrack& possibleParent, const SimTrack* probe) const;
    int createMergedSimClusterID(SimCluster* sc, double idenfrac=0.9) const;
    static bool simTrackEqual(const SimTrack&, const SimTrack&);
    
  private:
    
    void createIdxAssociation();
    const std::vector<SimTrack> simtracks_;
    const std::vector<SimVertex> simvertices_;
    std::map<int, int> trackIdToTrackIdxAssociation_;
};

#endif
