#include <catch2/catch.hpp>
#include "../interface/HitsSoA.h"

TEST_CASE("HitsSoA_Constructor") {
  HitsSoA hitsSoA;
  REQUIRE(hitsSoA.energy.size() == 0);
  REQUIRE(hitsSoA.x.size() == 0);
  REQUIRE(hitsSoA.y.size() == 0);
  REQUIRE(hitsSoA.z.size() == 0);
  REQUIRE(hitsSoA.time.size() == 0);
  REQUIRE(hitsSoA.fraction.size() == 0);
  REQUIRE(hitsSoA.id.size() == 0);
  REQUIRE(hitsSoA.clusterIndex.size() == 0);
}

TEST_CASE("HitsSoA_Resize") {
  HitsSoA hitsSoA;
  size_t size = 10;
  hitsSoA.resize(size);
  REQUIRE(hitsSoA.energy.size() == 10);
  REQUIRE(hitsSoA.x.size() == 10);
  REQUIRE(hitsSoA.y.size() == 10);
  REQUIRE(hitsSoA.z.size() == 10);
  REQUIRE(hitsSoA.time.size() == 10);
  REQUIRE(hitsSoA.fraction.size() == 10);
  REQUIRE(hitsSoA.id.size() == 10);
  REQUIRE(hitsSoA.clusterIndex.size() == 10);
  size_t new_size = 5;
  hitsSoA.resize(new_size);
  REQUIRE(hitsSoA.energy.size() == 5);
  REQUIRE(hitsSoA.x.size() == 5);
  REQUIRE(hitsSoA.y.size() == 5);
  REQUIRE(hitsSoA.z.size() == 5);
  REQUIRE(hitsSoA.time.size() == 5);
  REQUIRE(hitsSoA.fraction.size() == 5);
  REQUIRE(hitsSoA.id.size() == 5);
  REQUIRE(hitsSoA.clusterIndex.size() == 5);
}

TEST_CASE("HitsSoA_Clear") {
  HitsSoA hitsSoA;
  hitsSoA.resize(10);
  hitsSoA.clear();
  REQUIRE(hitsSoA.energy.size() == 0);
  REQUIRE(hitsSoA.x.size() == 0);
  REQUIRE(hitsSoA.y.size() == 0);
  REQUIRE(hitsSoA.z.size() == 0);
  REQUIRE(hitsSoA.time.size() == 0);
  REQUIRE(hitsSoA.fraction.size() == 0);
  REQUIRE(hitsSoA.id.size() == 0);
  REQUIRE(hitsSoA.clusterIndex.size() == 0);
}
