#include "../interface/SimHistoryTool.h"

#include <catch2/catch.hpp>

TEST_CASE("SimHistoryTool_CreateMergedSimClusterID") {
  std::vector<SimTrack> sts;
  sts.push_back(SimTrack(1,1, 1, Vector4D(1, 1, 1, 1), 0, 1, Vector3D(1, 1, 1), Vector4D(1, 1, 1, 1)));
  sts.push_back(SimTrack(2,2, 2, Vector4D(2, 2, 2, 2), 0, 2, Vector3D(2, 2, 2), Vector4D(2, 2, 2, 2)));
  sts.push_back(SimTrack(3,3, 3, Vector4D(3, 3, 3, 3), 0, 3, Vector3D(3, 3, 3), Vector4D(3, 3, 3, 3)));
  sts.push_back(SimTrack(4,4, 4, Vector4D(4, 4, 4, 4), 0, 4, Vector3D(4, 4, 4), Vector4D(4, 4, 4, 4)));
  sts.push_back(SimTrack(5,5, 5, Vector4D(5, 5, 5, 5), 0, 5, Vector3D(5, 5, 5), Vector4D(5, 5, 5, 5)));

  std::vector<SimVertex> svs;
  svs.push_back(SimVertex(Vector3D(1, 1, 1), 1, 1, 1));
  SimShower* sc = new SimShower();
  for (const auto &st : sts) {
    sc->addG4Tracks(st);
  }
  SimHistoryTool sht(sts, svs);
  int mergedPdgId = sht.createMergedSimClusterID(sc);
  REQUIRE(mergedPdgId == 1);
}
